#property strict

class FILE
{
public:
  static bool StringToFile( const string FileName, const string Str )
  {
    bool Res = FALSE;
    const int handle = FileOpen(FileName, FILE_WRITE | FILE_BIN);

    if (handle >= 0)
    {
      Res = (FileWriteString(handle, Str) != 0);

      FileClose(handle);
    }

    return(Res);
  }

  static bool FileWriteStringBIN( const int handle, const string Str )
  {
    if ((Str == "") || (Str == NULL))
      return(FileWriteInteger(handle, 0) != 0);

    uchar Result[];
    bool Res = (FileWriteInteger(handle, StringToCharArray(Str, Result)) != 0);

    if (Res)
      Res = (FileWriteArray(handle, Result) != 0);

    return(Res);
  }

  static string FileReadStringBIN( const int handle )
  {
    string Str = "";
    const int Size = FileReadInteger(handle);

    if (Size > 0)
    {
      uchar Result[];

      FileReadArray(handle, Result, 0, Size);

      Str = CharArrayToString(Result);
    }

    return(Str);
  }

  static string FileToString( const string FileName, const int TimeOut )
  {
    string Headers;
    char Post[], Result[];
    string Str = "";

    ResetLastError();

    if (WebRequest("GET", FileName, NULL, NULL, TimeOut, Post, 0, Result, Headers) != -1)
      Str = CharArrayToString(Result);
    else
    {
      Print("  WebRequest.    = " + (string)GetLastError());
      Print("   '" + FileName + "'    URL   ''");
    }

    return(Str);
   }

  static string FileToString( const string FileName )
  {
    uchar Result[];
    string Str = "";

    const int handle = FileOpen(FileName, FILE_READ | FILE_BIN);

    if (handle >= 0)
    {
      const int Size = (int)FileSize(handle);

      ArrayResize(Result, Size);

      if (FileReadArray(handle, Result) > 0)
        Str = CharArrayToString(Result);

      FileClose(handle);
    }

    return(Str);
  }
};